intelligent-things
==================

Publisher/subscriber IoT data system using the open-source Eclipse Mosquitto MQTT message broker and custom clients: https://mosquitto.org

This code base has been developed by [ZKM | Hertz-Lab](https://zkm.de/en/about-the-zkm/organization/hertz-lab) as part of the project [»The Intelligent Museum«](#the-intelligent-museum). 

Copyright (c) 2023 ZKM | Karlsruhe.  
Copyright (c) 2023 Dan Wilcox.  

BSD Simplified License.

**Note: currently under development. Usable but not stable or feature complete.**

Description
-----------

Publisher / Subscriber system using MQTT for communication:

* Mosquitto as minimal MQTT message broker
* Simple custom message history storage via SQLite database (or equivalent)
* Message history query and retrieval via custom API
* OSC <-> MQTT message relays ([skeeter](https://git.zkm.de/Hertz-Lab/Research/intelligent-museum/skeeter))
* Custom message relays (as needed, ex. from LIDAR system format)
* Fake sensor data generator / sender for testing
* Sensor data dashboard (using D3.js)

*Overview of each tool TBD*

Dependencies
------------

Python servers and programs:
* Python 3
* [paho-mqtt](https://github.com/eclipse/paho.mqtt.python)
* [python-osc](https://github.com/attwad/python-osc)

Browser applications:
* web browser with HTML5/JS/CSS3

Setup
-----

Install Python 3, if not already available. For instance, on macOS using [Homebrew](http://brew.sh):

```shell
brew install python3
```

In each Python project's directory, create a virtual environment and install the script's dependencies:

```shell
cd sensortest
make
```

The program cna then be run via the wrapper script, for example:

```shell
./sensortest localhost
```

Mosquitto
---------

Setup instructions in the [skeeter readme](https://git.zkm.de/Hertz-Lab/Research/intelligent-museum/skeeter#mosquitto) for now.

Usage
-----

*Usage info TBD.*

The Intelligent Museum
----------------------

An artistic-curatorial field of experimentation for deep learning and visitor participation

The [ZKM | Center for Art and Media](https://zkm.de/en) and the [Deutsches Museum Nuremberg](https://www.deutsches-museum.de/en/nuernberg/information/) cooperate with the goal of implementing an AI-supported exhibition. Together with researchers and international artists, new AI-based works of art will be realized during the next four years (2020-2023).  They will be embedded in the AI-supported exhibition in both houses. The Project „The Intelligent Museum” is funded by the Digital Culture Programme of the [Kulturstiftung des Bundes](https://www.kulturstiftung-des-bundes.de/en) (German Federal Cultural Foundation) and funded by the [Beauftragte der Bundesregierung für Kultur und Medien](https://www.bundesregierung.de/breg-de/bundesregierung/staatsministerin-fuer-kultur-und-medien) (Federal Government Commissioner for Culture and the Media).

As part of the project, digital curating will be critically examined using various approaches of digital art. Experimenting with new digital aesthetics and forms of expression enables new museum experiences and thus new ways of museum communication and visitor participation. The museum is transformed to a place of experience and critical exchange.
